//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "prMain.h"
#include "uMessage.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFMain *FMain;
TGost  gost;
//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
    : TForm(Owner)
{
    memset(Key256,0,8);
    gost.InitKey(Key256);
    Sp64 = gost.GetSinhro();// 
    gost.InitTable(tbl);
    tcode = fgame_os; //  {fbase,fgame,fgame_os}
    mcode = b256; //   {b64,b256}
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btnOpenClick(TObject *Sender)
{

    String s;
    r1->Lines->Clear();
    if(opend->Execute())
    {
        FNameIn = opend->FileName;
        fsize = GetSizeFile(FNameIn.c_str());
        if(opend->FilterIndex == 2)//  
        {

           if(fsize>300000)
            r2->Lines->Add(s.sprintf(" '%s'\r\n   [%ld ] \r\n  ",FNameIn.c_str(),fsize/1024));
            else
            r2->Lines->LoadFromFile(FNameIn);
           if(opend->Execute())
           {
              FNameOut = opend->FileName;
           }
           else
           {
              FNameOut = ChangeFileExt(FNameIn,".tmp");
           }
           btnDeKode->Enabled = true;
        }
        else//   
        {
            FNameOut = ChangeFileExt(FNameIn,".krp");
            if(fsize>300000)
             r1->Lines->Add(s.sprintf(" '%s'\r\n   [%ld ] \r\n  ",FNameIn.c_str(),fsize/1024));
            else
             r1->Lines->LoadFromFile(FNameIn);
            btnKode->Enabled = true;
        }

    }
            lbNameIn->Caption = " : "+FNameIn+" [ "+IntToStr(fsize/1024)+" kb]";
            lbFileOut->Caption = "  : "+FNameOut;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btnKodeClick(TObject *Sender)
{
     Screen->Cursor =  crHourGlass;
     TFkode * frm = NULL;
     if(fsize >= 300000)
     {
        frm = new TFkode(this);
        frm->Show();
        frm->Update();
     }
     CheckPasw();
     SetParam();
     gost.InitGost();

//     gost.InitGost(Sp64,Key256,tbl,tcode,mcode);
     DWORD count = gost.KodeFile(FNameIn.c_str(),FNameOut.c_str(),true);
     Label1->Caption = ": "+IntToStr(count);
     rbRegim->OnClick(rbRegim);
     btnKode->Enabled = false;
     if(frm != NULL)
     {
        frm->Close();
        frm->Free();
     }
     Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btnDeKodeClick(TObject *Sender)
{
     TFkode * frm = NULL;
     Screen->Cursor =  crHourGlass;
     if(fsize >= 300000)
     {
        frm = new TFkode(this);
        frm->Show();
     }
     DWORD count = gost.KodeFile(FNameIn.c_str(),FNameOut.c_str(),false);
     r1->Lines->LoadFromFile(FNameOut);
     Label2->Caption = ": "+IntToStr(count)+" : "+IntToStr(r2->Text.Length());
     btnDeKode->Enabled = false;
     lbNameIn->Caption = " : "+ FNameOut;
     if(frm != NULL)
     {
        frm->Close();
        frm->Free();
     }
     Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::btnCloseClick(TObject *Sender)
{
    Close();
}

//---------------------------------------------------------------------------
void __fastcall TFMain::SetHexData(const char* fname_in)
{
   	FILE *FileIn;
    char s[17] = {0};
    char s1[9] = {0};
    char *ch, ch2[3] = {0};
	UINT_32 nitem,fsize, readf;
	UINT_64 *N;// = 0UL;
    if((fsize = GetSizeFile(fname_in))==0)
        return ;
    nitem = fsize/8 +(fsize%8 >0);
	if((FileIn = fopen(fname_in,"rb"))==NULL)
	{
		return;
	}
    N = (UINT_64*)calloc(nitem,sizeof(UINT_64));
    readf = fread(N,sizeof(N),nitem,FileIn);
    if(readf==0)
    {
        free(N);
        fclose(FileIn);
        return;
    }
    grid->RowCount = 0;
    grid->ColCount = 0;
    grid->RowCount = nitem;
    grid->ColCount = 10;
    for(int i=1;i<9;i++)
     grid->ColWidths[i] = 30;
    grid->ColWidths[9] = 200;
    grid->ColWidths[0] = 80;

    int x = 14;

    for(UINT_32 i=0;i < nitem;i++)
    {
      if(N[i]==0)
      {
         grid->RowCount = i;
         break;
      }
      strcpy(s1,Int64ToStr(N[i]));
      sprintf(s,"%LX",N[i]);
      for(int j=1;j<9;j++)
      {

        ch = &s[x];
        memcpy(ch2,ch,2);
        grid->Cells[j][i] = ch2;
        x -=2;
      }
      grid->Cells[9][i] = s1;
      grid->Cells[0][i] = IntToHex((int)i,8);
      x = 14;
    }
    free(N);
}
//---------------------------------------------------------------------------
void __fastcall TFMain::SetBinData(const char* fname_in)
{
   	FILE *FileIn;
    char s[65] = {0};
    char s1[9] = {0};
	UINT_32 nitem, fsize, readf;
	UINT_64 *N;// = 0UL;
    if((fsize = GetSizeFile(fname_in))==0)
        return ;
    nitem = fsize/8 +(fsize%8 >0);
	if((FileIn = fopen(fname_in,"rb"))==NULL)
	{
		return;
	}
    N = (UINT_64*)calloc(nitem,sizeof(UINT_64));
    readf = fread(N,sizeof(N),nitem,FileIn);
    if(readf==0)
    {
        free(N);
        fclose(FileIn);
        return;
    }

    grid->RowCount = nitem;
    grid->ColCount = 3;
    grid->ColWidths[0] = 60;
    grid->ColWidths[1] = 400;
    grid->ColWidths[2] = 80;

    for(UINT_32 i=0;i < nitem;i++)
    {
      if(N[i]==0)
      {
         grid->RowCount = i;
         break;
      }
      strcpy(s,Int64ToBin(N[i]));
      s[64] = 0;
      strcpy(s1,Int64ToStr(N[i]));
      grid->Cells[0][i] = IntToStr(i);
      grid->Cells[1][i] = s;
      grid->Cells[2][i] = s1;
      ZeroMemory(s,65);
    }
    free(N);
}

//---------------------------------------------------------------------------
void __fastcall TFMain::rbRegimClick(TObject *Sender)
{

    String s;
    Screen->Cursor =  crHourGlass;
    if(fsize >= 300000)
    {
      if(r2->Lines->Count>0)
        r2->Lines->Clear();
      r2->Lines->Add(s.sprintf(" '%s'\r\n   [%ld ] \r\n  ",FNameOut.c_str(),fsize/1024));
      pag->ActivePageIndex = 0;
      return;
    }
    pag->ActivePageIndex = (rbRegim->ItemIndex > 0);
    if(FNameOut=="")return;
    switch(rbRegim->ItemIndex)
    {
        case 0: {

                   r2->Lines->LoadFromFile(FNameOut);
                   break;
        }
        case 1: {
                   SetHexData(FNameOut.c_str());
                   break;
        }
        case 2: {
                   SetBinData(FNameOut.c_str());
                   break;
        }
    }
    Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------
void __fastcall TFMain::pagChange(TObject *Sender)
{
   if(pag->ActivePageIndex == 0)
     rbRegim->ItemIndex = 0;
   if(pag->ActivePageIndex == 2)
     rbRegim->Enabled = false;
   else
     rbRegim->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnCreateKey32Click(TObject *Sender)
{
    char s[5],s1[5];
    Key256[0] = gost.Rand32Char();
    Key256[1] = gost.Rand32Char();
    Int32ToStr(s,Key256[0]);
    Int32ToStr(s1,Key256[1]);
    edKey32->Text = edKey32->Text.sprintf("%s%s",s,s1);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::chViewKey32Click(TObject *Sender)
{
    edKey32->PasswordChar =  (chViewKey32->Checked)?0:'*';
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnCreateKey64Click(TObject *Sender)
{
    memset(Key256,0,8);
    for(int i=0;i<8;i++)
    {
      Key256[i] = gost.GetRand32();
    }
    rdKeyView->OnClick(rdKeyView);

}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnCreateSinhroClick(TObject *Sender)
{
    char s[17] = {0};
    Sp64 = gost.GetSinhro();
    Int64ToHex(s,Sp64);
    edSinhro->Text = s;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::boxTypeKodChange(TObject *Sender)
{
    if(boxTypeKod->ItemIndex>0)
    {
        edKey32->Enabled = false;
        btnCreateKey32->Enabled = false;
        chViewKey32->Enabled = false;
        edKey64->Enabled = true;
        btnCreateKey64->Enabled = true;
        rdKeyView->Enabled = true;
    }
    else
    {
        edKey32->Enabled = true;
        btnCreateKey32->Enabled = true;
        chViewKey32->Enabled = true;
        edKey64->Enabled = false;
        btnCreateKey64->Enabled = false;
        rdKeyView->Enabled = false;
    }
    mcode = boxTypeKod->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnCreateBlockClick(TObject *Sender)
{
    gost.InitTable(tbl);
    SetGridTable(tbl);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::boxRegimChange(TObject *Sender)
{
    if(boxRegim->ItemIndex==0)
    {
       edSinhro->Enabled = false;
       btnCreateSinhro->Enabled = false;
    }
    else
    {
       edSinhro->Enabled = true;
       btnCreateSinhro->Enabled = true;
    }
    tcode = boxRegim->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::rdKeyViewClick(TObject *Sender)
{
    if(fsize > 5000) return;
    switch(rdKeyView->ItemIndex)
    {
       case 0:edKey64->Text = GetNumberKey256(Key256);break;
       case 1:edKey64->Text = GetHexKey256(Key256);break;
    }
}

//-   HEX  256   -------------------------------------
String __fastcall TFMain::GetHexKey256(Key32 k)
{
    String ss,str = ' ';
    for(int i=0;i<8;i++)
    {
      ss = IntToHex((int)k[i],1);
      str += ss+'-';
    }
    return str;
}

//-     256   -------------------------------------
String __fastcall TFMain::GetStrKey256(Key32 k)
{
    char s[9] = {0};
    String ss,str = ' ';
    for(int i=0;i<8;i++)
    {

      Int32ToStr(s,k[i]);
      ss = s;
      str += ss+'-';
    }
    return str;
}

//-     256   -------------------------------------
String __fastcall TFMain::GetNumberKey256(Key32 k)
{
    String str = '-';
    for(int i=0;i<8;i++)
    {
      str += IntToStr(k[i]);
    }
    return str;
}
//-----------------------------------------------------------------------------------------

void __fastcall TFMain::SetGridTable(BLOCK tb)
{
    register i,j;
    for(i=0;i<8;i++)
    {
        for(j=0;j<16;j++)
         gridBlock->Cells[j][i] = IntToStr(tb[j][i]);
    }
}

//      ,      -----------------------------------------
bool __fastcall TFMain::CheckPasw()
{
    if(mcode == b64)
    {
        edKey32->GetTextBuf(pasw,9);
        if(gost.SetKey(pasw)==false)
        {
           MessageBox(GetActiveWindow(),
                      "   \n   8 \n ",
                      "  ",
                      MB_OK|MB_ICONQUESTION);
           edKey32->SetFocus();
           edKey32->SelectAll();
           return false;
        }
    }
    return true;
}
//---------     -------------------------------------------------
void __fastcall TFMain::btnSaveBlockClick(TObject *Sender)
{
    String fname;
    if(InputQuery(" ","  ",fname))
    {
      if(SaveDataFile(fname.c_str(),tbl,sizeof(BLOCK))==false)
      {
        fname =  "  c : " +fname;
        MessageBox(GetActiveWindow(),fname.c_str(),
                   " ",
                   MB_OK|MB_ICONQUESTION);
      }

    }
}
//------------  ---------------------------------

void __fastcall TFMain::btnLoadBlockClick(TObject *Sender)
{
    String fname;
    if(InputQuery(" ","      ",fname))
    {
      if(LoadDataFile(fname.c_str(),tbl,sizeof(BLOCK))==false)
      {
        fname =  "   : " +fname;
        MessageBox(GetActiveWindow(),fname.c_str(),
                   " ",
                   MB_OK|MB_ICONQUESTION);
      }
      else SetGridTable(tbl);

    }
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnSaveAllClick(TObject *Sender)
{
    char fname[MAXPATH] = {0};
    if(saved->Execute())
    {
       strcpy(fname,saved->FileName.c_str());
       if(gost.SaveParametr(fname,NULL)==false)
       {
          InfoMessage(saved->FileName.sprintf("     : %s",fname).c_str()," ",MB_OK|MB_ICONQUESTION);

       }
    }
}

//---------------------------------------------------------------------------
void __fastcall TFMain::InfoMessage(LPCSTR mes,LPCSTR caption, DWORD flag)
{
   MessageBox(GetActiveWindow(),mes,caption,flag);
}

//---------------------------------------------------------------------------
void __fastcall TFMain::btnLoadAllClick(TObject *Sender)
{
     char fname[MAXPATH] = {0};
    if(opend->Execute())
    {
       strcpy(fname,opend->FileName.c_str());
       if(gost.LoadParametr(fname,NULL)==false)
       {
          InfoMessage(saved->FileName.sprintf("     : %s",fname).c_str()," ",MB_OK|MB_ICONQUESTION);

       }
       else LoadDataToComp();
    }
}
//---------------------------------------------------------------------------
void __fastcall TFMain::LoadDataToComp()
{
    char s[17] = {0};
    Sp64   = gost.GetSinhro();
    tcode  = gost.GetType();
    mcode  = gost.GetMode();
    gost.GetKey(Key256);
    gost.GetTable(tbl);
    SetGridTable(tbl);
    Int64ToHex(s,Sp64);
    edSinhro->Text = s;
    rdKeyView->OnClick(rdKeyView);
    boxTypeKod->OnChange(boxTypeKod);
}
void __fastcall TFMain::FormShow(TObject *Sender)
{
    LoadDataToComp(); //     
}
//---------------------------------------------------------------------------
void __fastcall TFMain::SetParam()
{
    LPGOSTPAR p = gost.GetParamter();
    p->SetKey(Key256);
    p->SetTable(tbl);
    p->SP= Sp64;
    p->type =tcode;
    p->mode =mcode;
}

//---------------------------------------------------------------------------
