//---------------------------------------------------------------------------

#ifndef prMainH
#define prMainH
//---------------------------------------------------------------------------
#include "CGost.h"
#include <dir.h>
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Grids.hpp>
#include <Buttons.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TFMain : public TForm
{
__published:	// IDE-managed Components
    TOpenDialog *opend;
    TLabel *Label1;
    TLabel *Label2;
    TPanel *Panel1;
    TRichEdit *r1;
    TLabel *lbFileOut;
    TPageControl *pag;
    TSplitter *Splitter1;
    TTabSheet *TabSheet1;
    TLabel *lbNameIn;
    TTabSheet *TabSheet4;
    TPanel *Panel2;
    TButton *btnOpen;
    TButton *btnKode;
    TButton *btnDeKode;
    TButton *btnClose;
    TRichEdit *r2;
    TTabSheet *TabSheet2;
    TStringGrid *grid;
    TRadioGroup *rbRegim;
    TGroupBox *GroupBox1;
    TComboBox *boxRegim;
    TGroupBox *GroupBox2;
    TComboBox *boxTypeKod;
    TEdit *edKey32;
    TLabel *Label5;
    TSpeedButton *btnCreateKey32;
    TCheckBox *chViewKey32;
    TEdit *edSinhro;
    TLabel *Label6;
    TCheckBox *chImito;
    TGroupBox *GrBoxKey256;
    TEdit *edKey64;
    TSpeedButton *btnCreateSinhro;
    TGroupBox *GroupBox4;
    TSpeedButton *btnCreateKey64;
    TRadioGroup *rdKeyView;
    TSpeedButton *btnCreateBlock;
    TSpeedButton *btnLoadBlock;
    TSpeedButton *btnSaveBlock;
    TSpeedButton *btnLoadAll;
    TSpeedButton *btnSaveAll;
    TStringGrid *gridBlock;
    TSaveDialog *saved;
    void __fastcall btnOpenClick(TObject *Sender);
    void __fastcall btnKodeClick(TObject *Sender);
    void __fastcall btnDeKodeClick(TObject *Sender);
    void __fastcall btnCloseClick(TObject *Sender);
    void __fastcall rbRegimClick(TObject *Sender);
    void __fastcall pagChange(TObject *Sender);
    void __fastcall btnCreateKey32Click(TObject *Sender);
    void __fastcall chViewKey32Click(TObject *Sender);
    void __fastcall btnCreateKey64Click(TObject *Sender);
    void __fastcall btnCreateSinhroClick(TObject *Sender);
    void __fastcall boxTypeKodChange(TObject *Sender);
    void __fastcall btnCreateBlockClick(TObject *Sender);
    void __fastcall boxRegimChange(TObject *Sender);
    void __fastcall rdKeyViewClick(TObject *Sender);
    void __fastcall btnSaveBlockClick(TObject *Sender);
    void __fastcall btnLoadBlockClick(TObject *Sender);
    void __fastcall btnSaveAllClick(TObject *Sender);
    void __fastcall btnLoadAllClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
private:	// User declarations
    String FNameIn,FNameOut;
    char pasw[9];
    Key32   Key256;  //  256 
    UINT_64 Sp64;// 
    UINT_32 fsize;
    BLOCK tbl;
    TYPEKOD tcode; //  {fbase,fgame,fgame_os}
    MODEKOD mcode; //   {b64,b256}
    String __fastcall GetHexKey256(Key32 k);
    String __fastcall GetStrKey256(Key32 k);
    String __fastcall GetNumberKey256(Key32 k);
    void __fastcall SetGridTable(BLOCK tb);
    bool __fastcall CheckPasw();
    void __fastcall InfoMessage(LPCSTR mes,LPCSTR caption, DWORD flag);
    void __fastcall LoadDataToComp();
    void __fastcall SetParam();
public:		// User declarations
    __fastcall TFMain(TComponent* Owner);
    void __fastcall SetHexData(const char* fname_in);
    void __fastcall SetBinData(const char* fname_in);
};
//---------------------------------------------------------------------------
extern PACKAGE TFMain *FMain;
//---------------------------------------------------------------------------
#endif
